<?php
$zing_tickets_name = "Zingiri Tickets";
$zing_tickets_shortname = "zing_tickets";
$install_type = array("Clean" );
$zing_login_type = array("osTickets","WP");
//FIXME:EBO only add if Zingiri Hoster installed
//$zing_login_type[] = "Hoster";

$zing_tickets_options = array (

array(  "name" => "General settings",
            "type" => "heading",
			"desc" => "This section manages the Zingiri Tickets settings.",
),
array(	"name" => "Type of integration",
			"desc" => "Select the way you want to login. If you want to use your Wordpress users, select 'WP'. <br />If you want to use the osTickets users, select 'osTickets'",
			"id" => $zing_tickets_shortname."_login",
			"std" => "WP",
			"type" => "select",
			"options" => $zing_login_type),
);

function zing_tickets_add_admin() {

	global $zing_tickets_name, $zing_tickets_shortname, $zing_tickets_options;

	if ( $_GET['page'] == basename(__FILE__) ) {

		if ( 'update' == $_REQUEST['action'] ) {
			foreach ($zing_tickets_options as $value) {
				if( isset( $_REQUEST[ $value['id'] ] ) ) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
				} else { delete_option( $value['id'] );
				}
			}
			header("Location: options-general.php?page=zing_tickets_cp.php");
			die;
		}
		
		if ( 'install' == $_REQUEST['action'] ) {
			zing_tickets_activate();
			foreach ($zing_tickets_options as $value) {
				if( isset( $_REQUEST[ $value['id'] ] ) ) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
				} else { delete_option( $value['id'] );
				}
			}
			header("Location: options-general.php?page=zing_tickets_cp.php&installed=true");
			die;
		}

		if( 'uninstall' == $_REQUEST['action'] ) {
			zing_tickets_uninstall();
			foreach ($zing_tickets_options as $value) {
				delete_option( $value['id'] );
				update_option( $value['id'], $value['std'] );
			}
			header("Location: options-general.php?page=zing_tickets_cp.php&uninstalled=true");
			die;
		}
	}

	add_options_page($zing_tickets_name." Options", "$zing_tickets_name", 8, basename(__FILE__), 'zing_tickets_admin');
}

function zing_tickets_admin() {

	global $zing_tickets_name, $zing_tickets_shortname, $zing_tickets_options;

	if ( $_REQUEST['installed'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_tickets_name.' installed.</strong></p></div>';
	if ( $_REQUEST['uninstalled'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_tickets_name.' uninstalled.</strong></p></div>';

	?>
<div class="wrap">
<h2><b><?php echo $zing_tickets_name; ?></b></h2>

	<?php
	$zing_tickets_version=get_option("zing_tickets_version");
	if (empty($zing_tickets_version))
	echo 'Please proceed with a clean install or deactivate your plugin';
	elseif ($zing_tickets_version != ZING_TICKETS_VERSION)
	echo 'You downloaded version '.ZING_TICKETS_VERSION.' and need to upgrade your database (currently at version '.$zing_tickets_version.').';
	elseif ($zing_tickets_version == ZING_TICKETS_VERSION)
	echo 'Your version is up to date!';

	?>
<form method="post">

<table class="optiontable">

<?php foreach ($zing_tickets_options as $value) {

	if ($value['type'] == "text") { ?>

	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><input name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>"
			value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>"
			size="40" /></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "textarea") { ?>
	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><textarea name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>" cols="50" rows="8" />
			<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes (get_settings( $value['id'] )); }
			else { echo $value['std'];
			} ?>
</textarea></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "select") { ?>

	<tr align="left">
		<th scope="top"><?php echo $value['name']; ?>:</th>
		<td><select name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>">
			<?php foreach ($value['options'] as $option) { ?>
			<option
			<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option>
			<?php } ?>
		</select></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "heading") { ?>

	<tr valign="top">
		<td colspan="2" style="text-align: left;">
		<h2 style="color: green;"><?php echo $value['name']; ?></h2>
		</td>
	</tr>
	<tr>
		<td colspan=2><small>
		<p style="color: red; margin: 0 0;"><?php echo $value['desc']; ?></P>
		</small>
		<hr />
		</td>
	</tr>

	<?php } ?>
	<?php
}
?>
</table>

<?php if (!$zing_tickets_version) { ?>
<p class="submit"><input name="install" type="submit" value="Install" />
<input type="hidden" name="action" value="install" /></p>

<?php } elseif ($zing_tickets_version != ZING_TICKETS_VERSION) { ?>
<p class="submit"><input name="install" type="submit" value="Upgrade" />
<input type="hidden" name="action" value="install" /></p>

<?php } else { ?>

<p class="submit"><input name="install" type="submit" value="Update" />
<input type="hidden" name="action" value="update" /></p>

<?php } ?>

</form>

<?php if ($zing_tickets_version) { ?>
<hr />
<p> Please note that more settings are available through the osTickets <a href="<?php echo get_option('home');?>/?zscp=admin.php&t=settings">admin panel</a>.</p>
<hr />
<form method="post">
<p class="submit"><input name="uninstall" type="submit"
	value="Uninstall" /> <input type="hidden" name="action"
	value="uninstall" /></p>
</form>
<?php } ?>
<hr />
<p>For more info and support, contact us at <a
	href="http://www.zingiri.com/tickets/">Zingiri</a> or check out our <a
	href="http://forums.zingiri.com/">support forums</a>.</p>
<?php
}
add_action('admin_menu', 'zing_tickets_add_admin'); ?>