<?php
/*  zingiri_tickets.php
 Copyright 2008,2009 Erik Bogaerts
 Support site: http://www.zingiri.com

 This file is part of Zingiri Tickets.

 Zingiri Tickets is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Zingiri Tickets is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with FreeWebshop.org; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?php
/*
 Plugin Name: Zingiri Tickets
 Plugin URI: http://www.zingiri.com/Tickets
 Description: This plugin integrates the fabulous osTicket ticketing solution with Wordpress.
 Author: Erik Bogaerts
 Version: 0.6
 Author URI: http://www.zingiri.com/
 */
define("ZING_TICKETS_VERSION","0.6");
// Pre-2.6 compatibility for wp-content folder location
if (!defined("WP_CONTENT_URL")) {
	define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
}
if (!defined("WP_CONTENT_DIR")) {
	define("WP_CONTENT_DIR", ABSPATH . "wp-content");
}

if (!defined("ZING_TICKETS_PLUGIN")) {

	$zing_tickets_plugin=substr(dirname(__FILE__),strlen(WP_CONTENT_DIR)+9,strlen(dirname(__FILE__))-strlen(WP_CONTENT_DIR)-9);
	define("ZING_TICKETS_PLUGIN", $zing_tickets_plugin);
}

if (!defined("ZING_TICKETS_SUB")) {
	if (get_option("siteurl") == get_option("home"))
	{
		define("ZING_TICKETS_SUB", "wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
	else {
		define("ZING_TICKETS_SUB", "wordpress/wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
}
if (!defined("ZING_TICKETS_DIR")) {
	define("ZING_TICKETS_DIR", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
}

if (!defined("ZING_TICKETS_LOC")) {
	define("ZING_TICKETS_LOC", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/");
}

if (!defined("ZING_TICKETS_URL")) {
	define("ZING_TICKETS_URL", WP_CONTENT_URL . "/plugins/".ZING_TICKETS_PLUGIN."/");
}
if (!defined("ZING_TICKETS_LOGIN")) {
	define("ZING_TICKETS_LOGIN", get_option("zing_tickets_login"));
}

define('DBHOST',DB_HOST);
define('DBNAME',DB_NAME);
define('DBUSER',DB_USER);
define('DBPASS',DB_PASSWORD);
define('TABLE_PREFIX',$wpdb->prefix."zing_ost_");
$zing_tickets_version=get_option("zing_tickets_version");
if ($zing_tickets_version) {
	add_action("init","zing_tickets_init");
	//add_filter('option_art_footer_content','zing_tickets_footer');
	add_filter('wp_footer','zing_tickets_footer');
	//add_filter('get_pages','zing_tickets_exclude_pages');
	add_action("plugins_loaded", "zing_tickets_sidebar_init");
	add_filter('the_content', 'zing_tickets_content', 10, 3);
	//add_action('get_header','zing_tickets_get_header');
	add_action('wp_head','zing_tickets_header');
}

register_activation_hook(__FILE__,'zing_tickets_activate');
register_deactivation_hook(__FILE__,'zing_tickets_deactivate');

require_once(dirname(__FILE__) . '/zing_tickets_cp.php');

/**
 * Activation of web shop: creation of database tables & set up of pages
 * @return unknown_type
 */
function zing_tickets_activate() {
	global $wpdb;
	global $current_user;
	global $zing_tickets_options;

	$zing_tickets_version=get_option("zing_tickets_version");
	if (!$zing_tickets_version)
	{
		add_option("zing_tickets_version",ZING_TICKETS_VERSION);
	}
	else
	{
		update_option("zing_tickets_version",ZING_TICKETS_VERSION);
	}

	//create database tables
	$wpdb->show_errors();
	$prefix=$wpdb->prefix."zing_ost_";

	if ($handle = opendir(dirname(__FILE__).'/db')) {
		while (false !== ($file = readdir($handle))) {
			if (strstr($file,".sql")) {
				$f=explode("-",$file);
					
				$v=str_replace(".sql","",$f[1]);
				if ($zing_version < $v) {
					$file_content = file(dirname(__FILE__).'/db/'.$file);
					$query = "";
					foreach($file_content as $sql_line) {
						$tsl = trim($sql_line);
						if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
							$sql_line = str_replace("CREATE TABLE `", "CREATE TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("INSERT INTO `", "INSERT INTO `".$prefix, $sql_line);
							$sql_line = str_replace("ALTER TABLE `", "ALTER TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("UPDATE `", "UPDATE `".$prefix, $sql_line);
							$sql_line = str_replace("TRUNCATE TABLE `", "TRUNCATE TABLE `".$prefix, $sql_line);
							$query .= $sql_line;

							if(preg_match("/;\s*$/", $sql_line)) {
								$wpdb->query($query);
								$query = "";
							}
						}

					}
				}
			}
		}
		closedir($handle);
	}

	//default settings
	if ($zing_tickets_version <= '0.1') {
		$query="update ".$prefix."config set admin_email='".get_option('admin_email')."'";
		$query.=",helpdesk_url='".get_option('home')."'";
		$wpdb->query($query);
	}

	//default user
	if ($zing_tickets_version <= '0.1') {
		$query="INSERT INTO `wp_zing_ost_staff` (`staff_id`, `group_id`, `dept_id`, `username`, `firstname`, `lastname`, `passwd`, `email`, `phone`, `phone_ext`, `mobile`, `signature`, `isactive`, `isadmin`, `isvisible`, `onvacation`, `daylight_saving`, `append_signature`, `change_passwd`, `timezone_offset`, `max_page_size`, `created`, `lastlogin`, `updated`) VALUES";
		$query.="('".$current_user->data->ID."', 1, 1, '".$current_user->data->user_login."', '".$current_user->first_name."', '".$current_user->last_name."', '".$current_user->data->user_pass."', '".$current_user->data->user_email."', '', '', '', '', 1, 1, 1, 0, 0, 0, 1, 0.0, 0, '".date("Y-m-d")."', NULL, '".date("Y-m-d")."')";
		$wpdb->query($query);
	}

	//default options
	foreach ($zing_tickets_options as $value) {
		delete_option( $value['id'] );
		if ( !empty($value['id']) && !get_option($value['id']) ) update_option( $value['id'], $value['std'] );
	}
		
	//create standard pages
	if ($zing_tickets_version <= '0.1') {
		$pages=array();
		$pages[]=array("Tickets","tickets","*",0);

		$ids="";
		foreach ($pages as $i =>$p)
		{
			$my_post = array();
			$my_post['post_title'] = $p['0'];
			$my_post['post_content'] = '';
			$my_post['post_status'] = 'publish';
			$my_post['post_author'] = 1;
			$my_post['post_type'] = 'page';
			$my_post['menu_order'] = 100+$i;
			$id=wp_insert_post( $my_post );
			if (empty($ids)) { $ids.=$id; } else { $ids.=",".$id; }
			if (!empty($p[1])) add_post_meta($id,'zing_tickets_page',$p[1]);
		}
		if (get_option("zing_tickets_pages"))
		{
			update_option("zing_tickets_pages",$ids);
		}
		else {
			add_option("zing_tickets_pages",$ids);
		}
	}
}

/**
 * Deactivation of web shop
 * @return void
 */
function zing_tickets_deactivate() {
}

/**
 * Uninstallation of web shop: removal of database tables
 * @return void
 */
function zing_tickets_uninstall() {
	global $wpdb;

	$tables=array();
	$a='api_key,config,department,email,email_banlist,email_template,groups,help_topic,kb_premade,staff,syslog,ticket,ticket_attachment,ticket_lock,ticket_message,ticket_note,ticket_priority,ticket_response,timezone';
	$tables=explode(",",$a);
	$prefix=$wpdb->prefix."zing_ost_";
	foreach ($tables as $table) {
		$query="drop table ".$prefix.$table;
		$wpdb->query($query);
	}
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		wp_delete_post($id);
	}
	delete_option("zing_tickets_version",ZING_VERSION);
	delete_option("zing_tickets_pages",ZING_VERSION);
}

/**
 * Main function handling content, footer and sidebars
 * @param $process
 * @param $content
 * @return unknown_type
 */
function zing_tickets_main($process,$content="") {
	error_reporting(E_ALL & ~E_NOTICE);
	ini_set('display_errors', '1');
	global $post;
	global $wpdb;
	global $cfg;
	global $thisuser;
	global $nav;
	global $zing_tickets_loaded;

	include (ZING_TICKETS_LOC."./zing.globals.inc.php");

	switch ($process)
	{
		case "content":
			if (isset($_POST['zname'])) {
				$_POST['name']=$_POST['zname'];
				unset($_POST['zname']);
			}
			$cf=get_post_custom();
			if (isset($_GET['zpage']))
			{
				$to_include=$_GET['zpage'];
			}
			elseif (isset($_GET['zscp']))
			{
				$to_include="scp/".$_GET['zscp'];
			}
			elseif (isset($cf['zing_tickets_page']) && ($cf['zing_tickets_page'][0]=='tickets'))
			{
				$_GET['page']=$cf['zing_tickets_page'][0];
				if (isset($cf['zing_tickets_action']))
				{
					$_GET['action']=$cf['zing_tickets_action'][0];
				}
				if ($cf['zing_tickets_page'][0]=='tickets' && isset($_SESSION['_staff']) && count($_SESSION['_staff']) > 0) {
					$to_include="scp/index.php";
					unset($_SESSION['_client']);
				} else {
					unset($_SESSION['_staff']);
					$to_include="tickets.php";
				}
			}
			else
			{
				return $content;
			}
			if (isset($cf['cat'])) {
				$_GET['cat']=$cf['cat'][0];
			}
			break;
		case "footer":
			$to_include="footer.php";
			break;
		case "sidebar":
			$to_include="menu_".$content.".php";
			break;
	}
	if (!$zing_tickets_loaded)
	{
		$zing_tickets_loaded=TRUE;
	} else {
		//nothing to do
	}
	require(ZING_TICKETS_DIR.$to_include);
}

/**
 * Page content filter
 * @param $content
 * @return unknown_type
 */
function zing_tickets_content($content) {
	return zing_tickets_main("content",$content);
}


/**
 * Header hook: loads FWS addons and css files
 * @return unknown_type
 */
function zing_tickets_header()
{
	global $cfg;
	/*this css file can be activated if necessary but can cause conflicts with certain themes
	 * echo '<link rel="stylesheet" href="'.ZING_TICKETS_URL.'osticket/upload/scp/css/main.css" media="screen">';
	 */
	echo '<link rel="stylesheet" href="'.ZING_TICKETS_URL.'osticket/upload/scp/css/style.css" media="screen">';
	echo '<link rel="stylesheet" href="'.ZING_TICKETS_URL.'osticket/upload/scp/css/tabs.css" media="screen">';
	echo '<link rel="stylesheet" href="'.ZING_TICKETS_URL.'osticket/upload/scp/css/autosuggest_inquisitor.css" type="text/css" media="screen" charset="utf-8" />';
	echo '<link rel="stylesheet" type="text/css" href="' . ZING_TICKETS_URL . 'zing.css" media="screen" />';
	echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/ajax.js"></script>';
	echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/scp.js"></script>';
	echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/tabber.js"></script>';
	echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/calendar.js"></script>';
	echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/bsn.AutoSuggest_2.1.3.js" charset="utf-8"></script>';
	if ($cfg && $cfg->getLockTime()) { //autoLocking enabled
		echo '<script type="text/javascript" src="'.ZING_TICKETS_URL.'osticket/upload/scp/js/autolock.js" charset="utf-8"></script>';
	}
}

/**
 * Sidebar menu widget
 * @param $args
 * @return unknown_type
 */
function widget_zingiri_tickets_menu($args) {
	global $nav, $thisuser;

	extract($args);
	echo $before_widget;
	echo $before_title;
	echo "Tickets";
	echo $after_title;
	echo '<div id="zing-sidebar">';
	echo '<style type="text/css">';
	echo 'h1 {display:none; }';
	echo '</style>';
	echo '<ul>';
	if(is_Object($thisuser) && $thisuser->isAdmin() && !defined('ADMINPAGE')) {
		echo '<li><a href="admin.php">Admin Panel</a></li>';
	}else{
		echo '<li><a href="tickets.php">Staff Panel</a></li>';
	}

	if (is_Object($nav)) {
		$tabs=$nav->getTabs();
		if(($tabs=$nav->getTabs()) && is_array($tabs)){
			foreach($tabs as $tab) {
				echo '<li><a '.($tab['active']?'class="active"':'').' href="'.$tab['href'].'" title="'.$tab['title'].'">'.$tab['desc'].'</a>';
				if ($tab['active']) {
					$submenu=$nav->getSubMenu();
					if (count($submenu) > 0) {
						echo '<ul>';
						foreach ($submenu as $sub) {
							echo '<li><a href="'.$sub['href'].'">'.$sub['desc'].'</a></li>';
						}
						echo '</ul>';
					}
				}
				echo '</li>';
			}
		}
		$tabs=$nav->getTabs();
		foreach ($tabs as $tab) {
			if ($tab['active']) { $title=$tab['desc']; }
		}
	}
	
	if (!defined("ZING_TICKETS_LOGIN") || ZING_TICKETS_LOGIN == 'osTicket') echo '<li><a href="logout.php">Log Out</a></li>';
	else echo '<li><a href="'.wp_logout_url().'">Log Out</a></li>';
	echo '<ul>';
	echo '</div>';
	echo $after_widget;
}

/**
 * Register sidebar widgets
 * @return unknown_type
 */
function zing_tickets_sidebar_init()
{
	session_start();

	if (current_user_can('level_10') || ((isset($_SESSION['_staff']) && count($_SESSION['_staff']))) > 0) {
		register_sidebar_widget(__('Zingiri Tickets Menu'), 'widget_zingiri_tickets_menu');
	}
}

/**
 * Initialization of page, action & page_id arrays
 * @return unknown_type
 */
function zing_tickets_init()
{
	ob_start();

	global $dbtablesprefix;
	global $dblocation;
	global $dbname;
	global $dbuser;
	global $dbpass;
	global $current_user;
	global $cfg;
	global $is_IIS;

	$pageid=get_option("zing_tickets_pages");

	if (isset($_POST['name'])) {
		$_POST['zname']=$_POST['name'];
		unset($_POST['name']);
	}

	session_start();
	if (defined("ZING_TICKETS_LOGIN") && ZING_TICKETS_LOGIN=="WP") {
		require(dirname(__FILE__)."/osticket/upload/main.inc.php");

		if ($current_user->data->user_login) {
			$s=new StaffSession($current_user->data->user_login);
			$_SESSION['_staff']['userID']=$current_user->data->user_login;
			$s->refreshSession();
		} else {
			unset($_SESSION['_staff']);
		}
	}

	if (isset($_GET['zscp']) || isset($_GET['zpage'])) {
		if (isset($_SESSION['postit']) && count($_POST) == 0) {
			foreach ($_SESSION['postit'] as $id => $value) {
				$_POST[$id]=$value;
				$_REQUEST[$id]=$value;
			}
			unset($_SESSION['postit']);
		}
		return true;
	}
	$location=zing_tickets_Current_Page_URL();
	$home=get_option("home").'/';
	$s=str_replace($home,'',$location);
	$t=explode('?',$s);
	$page=$t[0];
	$vars=$t[1];

	$page=str_replace('/','',$page);

	if (isset($_SESSION['_staff']) && count($_SESSION['_staff']) > 0) {
		$goto='zscp';
	} else {
		$goto='zpage';
	}
	switch ($goto) {
		case "zpage":
			switch ($page) {
				case "open.php":
				case "tickets.php":
				case "view.php":
				case "login.php":
					break;
				default:
					return true;
					break;
			}
			break;

		case "zscp":
			switch ($page)
			{
				case "admin.php":
					break;
				case "kb.php":
					break;
				case "tickets.php":
					break;
				case "profile.php":
					//redirect to WP
					break;
				case "directory.php":
					break;
				case "logout.php":
					//redirect to WP
					break;
				case "login.php":
					//redirect to WP
					break;
				default:
					return true;
					break;
			}
			break;
	}
	unset($_SESSION['postit']);
	foreach ($_POST as $id => $value) {
		$_SESSION['postit'][$id]=$value;
	}

	if (!empty($vars)) $vars='&'.$vars;
	$location=$home.'index.php?page_id='.$pageid.'&'.$goto.'='.$page.$vars;

	$location = wp_sanitize_redirect($location);

	if ( $is_IIS ) {
		header("Refresh: 0;url=$location");
		die();
	} else {
		if ( php_sapi_name() != 'cgi-fcgi' )
		status_header($status); // This causes problems on IIS and some FastCGI setups
		header("Location: $location");
		die();
	}

}

function zing_tickets_Current_Page_URL() {
	$pageURL = 'http';
	if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} else {
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $pageURL;
}
/**
 * Look up FWS page name based on Wordpress page_id
 * @param $page_id
 * @return unknown_type
 */
function zing_tickets_page($page_id)
{
	global $zing_tickets_page_id_to_page;
	if (isset($zing_tickets_page_id_to_page[$page_id]))
	{
		return $zing_tickets_page_id_to_page[$page_id];
	}
	return "main";
}

/**
 * Look up Wordpress page_id based on FWS page and action
 * @param $page
 * @param $action
 * @return unknown_type
 */
function zing_tickets_page_id($page,$action="*")
{
	global $zing_tickets_page_to_page_id;

	if (isset($zing_tickets_page_to_page_id[$page][$action]))
	{
		return $zing_tickets_page_to_page_id[$page][$action];
	}
	elseif (isset($zing_tickets_page_to_page_id[$page]))
	{
		return $zing_tickets_page_to_page_id[$page];
	}
	return "";
}

/**
 * The footer is automatically inserted
 * For other themes, the function zing_footer should be called from inside the theme.
 * @param $footer
 * @return unknown_type
 */
function zing_tickets_footer($footer="")
{
	$bail_out = ( ( defined( 'WP_ADMIN' ) && WP_ADMIN == true ) || ( strpos( $_SERVER[ 'PHP_SELF' ], 'wp-admin' ) !== false ) );
	if ( $bail_out ) return $footer;
	//As a show of support please leave the Zingiri and osTicket URL's in the footer
	echo '<center style="margin-top:0px;font-size:smaller">Powered by <a href="http://www.zingiri.com" alt="Zingiri Tickets">Zingiri</a> & ';
	echo '<a href="http://osticket.com">osTicket</a></center>';
}
?>